package eu.jonahbauer.wizard.client.libgdx.screens;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Screen;
import com.badlogic.gdx.graphics.GL20;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.InputListener;
import com.badlogic.gdx.scenes.scene2d.Stage;
import com.badlogic.gdx.scenes.scene2d.ui.Skin;
import com.badlogic.gdx.scenes.scene2d.ui.TextButton;
import com.badlogic.gdx.scenes.scene2d.ui.TextField;
import com.badlogic.gdx.utils.viewport.ScreenViewport;
import eu.jonahbauer.wizard.client.libgdx.WizardGame;

public class CreateGameScreen implements Screen {

    Texture background;
    Texture topLeft;
    Texture topRight;
    Texture bottomLeft;
    Texture bottomRight;
    Texture wizard;

    TextButton backButton;
    TextButton continueButton;

    TextField option1;
    TextField option2;
    TextField option3;
    TextField option4;
    TextField option5;
    TextField option6;

    Skin skin;
    Stage stage;
    public WizardGame game;

    public CreateGameScreen(WizardGame game) {
        this.game = game;
    }

    @Override
    public void show() {
        skin = new Skin(Gdx.files.internal("skin/uiskin.json"));
        stage = new Stage(new ScreenViewport());

        background = new Texture(Gdx.files.internal("background.png"));

        topLeft = new Texture(Gdx.files.internal("ecke_lo.png"));
        topRight = new Texture(Gdx.files.internal("ecke_ro.png"));
        bottomLeft = new Texture(Gdx.files.internal("ecke_lu.png"));
        bottomRight = new Texture(Gdx.files.internal("ecke_ru.png"));

        wizard = new Texture(Gdx.files.internal("schriftzug_s.png"));

        backButton = new TextButton("Zurück", skin);
        backButton.setPosition(WizardGame.WIDTH * 0.3f, WizardGame.HEIGHT * 0.18f);
        backButton.setSize(120, backButton.getHeight());
        continueButton = new TextButton("Fortfahren", skin);
        continueButton.setPosition(WizardGame.WIDTH * 0.7f - continueButton.getWidth(), WizardGame.HEIGHT * 0.18f);

        option1 = new TextField("1", skin);
        option1.setPosition(WizardGame.WIDTH * 0.3f, WizardGame.HEIGHT * 0.6f);
        option1.setSize(250, continueButton.getHeight());
        option2 = new TextField("2", skin);
        option2.setPosition(option1.getX(), option1.getY() - WizardGame.HEIGHT * 0.12f);
        option2.setSize(250, continueButton.getHeight());
        option3 = new TextField("3", skin);
        option3.setPosition(option2.getX(), option2.getY() - WizardGame.HEIGHT * 0.12f);
        option3.setSize(250, continueButton.getHeight());

        option4 = new TextField("4", skin);
        option4.setPosition(WizardGame.WIDTH * 0.65f - option4.getWidth(), option1.getY());
        option4.setSize(250, continueButton.getHeight());
        option5 = new TextField("5", skin);
        option5.setPosition(option4.getX(), option2.getY());
        option5.setSize(250, continueButton.getHeight());
        option6 = new TextField("6", skin);
        option6.setPosition(option4.getX(), option3.getY());
        option6.setSize(250, continueButton.getHeight());


        Gdx.input.setInputProcessor(stage);
        stage.addActor(backButton);
        stage.addActor(continueButton);
        stage.addActor(option1);
        stage.addActor(option2);
        stage.addActor(option3);
        stage.addActor(option4);
        stage.addActor(option5);
        stage.addActor(option6);

        backButton.addListener(new InputListener() {
            @Override
            public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
                MainMenuScreen.buttonClickSound.play(0.6f);
                game.setScreen(new SessionListScreen(game));
                return true;
            }
        });

        continueButton.addListener(new InputListener() {
            @Override
            public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
                MainMenuScreen.buttonClickSound.play(0.6f);
                game.setScreen(new WaitingScreen(game));
                return true;
            }
        });
    }

    @Override
    public void render(float delta) {
        Gdx.gl.glClear(GL20.GL_COLOR_BUFFER_BIT);
        stage.act(Gdx.graphics.getDeltaTime());
        this.game.batch.begin();
        this.game.batch.draw(background, 0, 0);
        this.game.batch.draw(topLeft, 0, WizardGame.HEIGHT - topLeft.getHeight());
        this.game.batch.draw(topRight, WizardGame.WIDTH - topRight.getWidth(), WizardGame.HEIGHT - topRight.getHeight());
        this.game.batch.draw(bottomLeft, 0, 0);
        this.game.batch.draw(bottomRight, WizardGame.WIDTH - bottomRight.getWidth(), 0);
        this.game.batch.draw(wizard, (WizardGame.WIDTH / 2f) - (wizard.getWidth() / 2f), WizardGame.HEIGHT * 0.75f);
        this.game.batch.end();
        stage.draw();
    }

    @Override
    public void resize(int width, int height) {

    }

    @Override
    public void pause() {

    }

    @Override
    public void resume() {

    }

    @Override
    public void hide() {

    }

    @Override
    public void dispose() {

    }
}
